<?xml version="1.0" encoding="UTF-8"?>
<?eclipse version="3.4"?>
<!--
 #=============================================================================#
 # Copyright (c) 2005, 2025 Stephan Wahlbrink and others.
 # 
 # This program and the accompanying materials are made available under the
 # terms of the Eclipse Public License 2.0 which is available at
 # https://www.eclipse.org/legal/epl-2.0, or the Apache License, Version 2.0
 # which is available at https://www.apache.org/licenses/LICENSE-2.0.
 # 
 # SPDX-License-Identifier: EPL-2.0 OR Apache-2.0
 # 
 # Contributors:
 #     Stephan Wahlbrink <sw@wahlbrink.eu> - initial API and implementation
 #=============================================================================#
-->

<plugin>
   
   <extension-point id="org.eclipse.statet.ltk.AdvancedContentAssist"
         schema="schema/AdvancedContentAssist.exsd"
         name="Categories and computers for advanced content assist in editors"/>
   
   <extension-point id="org.eclipse.statet.ltk.AdvancedInfoHover"
         schema="schema/AdvancedInfoHover.exsd"
         name="Information hovers"/>
   
   <extension
         point="org.eclipse.ui.contexts">
      <context
            id="org.eclipse.statet.workbench.contexts.TextEditor"
            parentId="org.eclipse.ui.textEditorScope"
            name="%contexts_TextEditorScope_name"
            description="%contexts_TextEditorScope_description">
      </context>
      <context
            id="org.eclipse.statet.workbench.contexts.StructuredElementViewer"
            name="%contexts_StructuredElementViewer_name"
            description="%contexts_StructuredElementViewer_description">
      </context>
   </extension>
      
   <extension
         point="org.eclipse.ui.commands">
      <!-- edit -->
      <command
            id="org.eclipse.statet.workbench.commands.CopyElementName"
            categoryId="org.eclipse.ui.category.edit"
            name="%commands_CopyElementName_name"
            description="%commands_CopyElementName_description"
            />
      <command
            id="org.eclipse.statet.workbench.commands.PasteRaw"
            categoryId="org.eclipse.ui.category.edit"
            name="%commands_PasteRaw_name"
            description="%commands_PasteRaw_description"
            />
      <command
            id="org.eclipse.statet.workbench.commands.SelectExpandEnclosing"
            categoryId="org.eclipse.ui.category.edit"
            name="%commands_SelectEnclosing_name"
            description="%commands_SelectEnclosing_description"
            />
      <command
            id="org.eclipse.statet.workbench.commands.SelectExpandNext"
            categoryId="org.eclipse.ui.category.edit"
            name="%commands_SelectNext_name"
            description="%commands_SelectNext_description"
            />
      <command
            id="org.eclipse.statet.workbench.commands.SelectExpandPrevious"
            categoryId="org.eclipse.ui.category.edit"
            name="%commands_SelectPrevious_name"
            description="%commands_SelectPrevious_description"
            />
      <command
            id="org.eclipse.statet.workbench.commands.SelectLast"
            categoryId="org.eclipse.ui.category.edit"
            name="%commands_SelectLast_name"
            description="%commands_SelectLast_description"
            />
      <command
            id="org.eclipse.statet.ltk.commands.SpecificContentAssist"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_SpecificContentAssist_name"
            description="%commands_SpecificContentAssist_description">
         <commandParameter
               id="categoryId"
               name="%commands_SpecificContentAssist_param_CategoryId_name"
               optional="false"
               values="org.eclipse.statet.internal.ltk.ui.SpecificContentAssistParameterValues"/>
      </command>
      
      <!-- navigate -->
      <command
            id="org.eclipse.statet.ecommons.text.commands.GotoMatchingBracket"
            categoryId="org.eclipse.ui.category.navigate"
            name="%commands_GotoMatchingBracket_name"
            description="%commands_GotoMatchingBracket_description" />
      <command
            id="org.eclipse.statet.ltk.commands.ShowQuickSourceOutline"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_ShowQuickSourceOutline_name"
            description="%commands_ShowQuickSourceOutline_description"/>
      <command
            id="org.eclipse.statet.ltk.commands.ShowQuickElementOutline"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_ShowQuickElementOutline_name"
            description="%commands_ShowQuickElementOutline_description"/>
      <command
            id="org.eclipse.statet.ltk.commands.ShowQuickElementHierarchy"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_ShowQuickElementHierarchy_name"
            description="%commands_ShowQuickElementHierarchy_description"/>
      
      <!-- search -->
      <command
            id="org.eclipse.statet.workbench.commands.OpenSearchDialog"
            categoryId="org.eclipse.search.ui.category.search"
            name="Open Search Dialog"
            description="Opens the Search Dialog"
            defaultHandler="org.eclipse.statet.ecommons.workbench.search.ui.OpenSearchDialogHandler">
         <commandParameter
               id="pageId"
               name="Page"
               optional="true">
         </commandParameter>
      </command>
      <command
            id="org.eclipse.statet.ltk.commands.SearchAllElementAccess"
            categoryId="org.eclipse.search.ui.category.search"
            name="%commands_SearchAllElementAccess_name"
            description="%commands_SearchAllElementAccess_description">
         <commandParameter
               id="scope"
               optional="false"
               name="%commands_Search_ScopeParameter_name">
            <values
                  class="org.eclipse.ui.commands.ExtensionParameterValues">
               <parameter
                     name="%commands_Search_ScopeParameter_Workbench_name"
                     value="workbench"/>
               <parameter
                     name="%commands_Search_ScopeParameter_Project_name"
                     value="project"/>
               <parameter
                     name="%commands_Search_ScopeParameter_File_name"
                     value="file"/>
            </values>
         </commandParameter>
      </command>
      <command
            id="org.eclipse.statet.ltk.commands.SearchWriteElementAccess"
            categoryId="org.eclipse.search.ui.category.search"
            name="%commands_SearchWriteElementAccess_name"
            description="%commands_SearchWriteElementAccess_description">
         <commandParameter
               id="scope"
               optional="false"
               name="%commands_Search_ScopeParameter_name">
            <values
                  class="org.eclipse.ui.commands.ExtensionParameterValues">
               <parameter
                     name="%commands_Search_ScopeParameter_Workbench_name"
                     value="workbench"/>
               <parameter
                     name="%commands_Search_ScopeParameter_Project_name"
                     value="project"/>
               <parameter
                     name="%commands_Search_ScopeParameter_File_name"
                     value="file"/>
            </values>
         </commandParameter>
      </command>
      
      <!-- source -->
      <category
            id="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%categorys_StatetSource_name"
            description="%categorys_StatetSource_description" />
      <command
            id="org.eclipse.statet.ltk.commands.ToggleComment"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_ToggleComment_name"
            description="%commands_ToggleComment_description"/>
      <command
            id="org.eclipse.statet.ltk.commands.StripComments"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_StripComments_name"
            description="%commands_StripComments_description"
            />
      <command
            id="org.eclipse.statet.ltk.commands.InsertAssignment"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_InsertAssignment_name"
            description="%commands_InsertAssignment_description"
            />
      <command
            id="org.eclipse.statet.ltk.commands.AddDocComment"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_AddDocComment_name"
            description="%commands_AddDocComment_description"
            />
      <command
            id="org.eclipse.statet.ltk.commands.GenerateElementComment"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_GenerateElementComment_name"
            description="%commands_GenerateElementComment_description"
            />
      <command
            id="org.eclipse.statet.ltk.commands.CorrectIndent"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_CorrectIndent_name"
            description="%commands_CorrectIndent_description"/>
      <command
            id="org.eclipse.statet.ltk.commands.CorrectLineWrap"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_CorrectLineWrap_name"
            description="%commands_CorrectLineWrap_description"/>
      
      <command
            id="org.eclipse.statet.ltk.commands.ToggleLiveReportProblems"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_ToggleReportProblemWhenTyping_name"
            description="%commands_ToggleReportProblemWhenTyping_description"/>
      
      <!-- quick assist -->
      <command
            id="org.eclipse.statet.ltk.commands.QuickAssistRenameInFile"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_QuickAssistRenameInFile_name"
            description="%commands_QuickAssistRenameInFile_description"/>
      <command
            id="org.eclipse.statet.ltk.commands.QuickAssistConvertToPipeForward"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_QuickAssistConvertToPipeForward_name"
            description="%commands_QuickAssistConvertToPipeForward_description"/>
      
      <!-- refactor -->
      <command
            id="org.eclipse.statet.ltk.commands.RefactorRenameInWorkspace"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_RefactorRenameInWorkspace_name"
            description="%commands_RefactorRenameInWorkspace_description"/>
      <command
            id="org.eclipse.statet.ltk.commands.RefactorRenameInSelectedRegion"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_RefactorRenameInSelectedRegion_name"
            description="%commands_RefactorRenameInSelectedRegion_description"/>
      <command
            id="org.eclipse.statet.ltk.commands.RefactorInlineLocalVariable"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_RefactorInlineLocalVariable_name"
            description="%commands_RefactorInlineLocalVariable_description"/>
      <command
            id="org.eclipse.statet.ltk.commands.RefactorExtractLocalVariable"
            categoryId="org.eclipse.statet.workbench.commandCategorys.Source"
            name="%commands_RefactorExtractLocalVariable_name"
            description="%commands_RefactorExtractLocalVariable_description"/>
   </extension>
   <extension
         point="org.eclipse.ui.commandImages">
      <image
            commandId="org.eclipse.jdt.ui.edit.text.java.toggleMarkOccurrences"
            icon="icons/tool_16/mark_occurrences.png"
            disabledIcon="icons/tool_16/mark_occurrences$d.png" />
      <image
            commandId="org.eclipse.statet.workbench.commands.CopyElementName"
            icon="icons/tool_16/copy-name.png"
            disabledIcon="icons/tool_16/copy-name$d.png"/>
      <image
            commandId="org.eclipse.statet.workbench.commands.OpenSearchDialog"
            icon="icons/tool_16/search.png"
            disabledIcon="icons/tool_16/search$d.png"/>
      <image
            commandId="org.eclipse.statet.ltk.commands.QuickAssistRenameInFile"
            icon="icons/tool_16/assist-linked_rename.png"
            disabledIcon="icons/tool_16/assist-linked_rename$d.png"/>
   </extension>
   
   <extension
         point="org.eclipse.ui.bindings">
         
      <key
            commandId="org.eclipse.statet.workbench.commands.SelectExpandEnclosing"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M2+M3+ARROW_UP"/>
      <key
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            platform="carbon"
            sequence="M2+M3+ARROW_UP"/>
      <key
            commandId="org.eclipse.statet.workbench.commands.SelectExpandEnclosing"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            platform="carbon"
            sequence="CTRL+SHIFT+ARROW_UP"/>
      <key
            commandId="org.eclipse.statet.workbench.commands.SelectExpandNext"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M2+M3+ARROW_RIGHT"/>
      <key
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            platform="carbon"
            sequence="M2+M3+ARROW_RIGHT"/>
      <key
            commandId="org.eclipse.statet.workbench.commands.SelectExpandNext"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            platform="carbon"
            sequence="CTRL+SHIFT+ARROW_RIGHT"/>
      <key
            commandId="org.eclipse.statet.workbench.commands.SelectExpandPrevious"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M2+M3+ARROW_LEFT"/>
      <key
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            platform="carbon"
            sequence="M2+M3+ARROW_LEFT"/>
      <key
            commandId="org.eclipse.statet.workbench.commands.SelectExpandPrevious"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            platform="carbon"
            sequence="CTRL+SHIFT+ARROW_LEFT"/>
      <key
            commandId="org.eclipse.statet.workbench.commands.SelectLast"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M2+M3+ARROW_DOWN"/>
      <key
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            platform="carbon"
            sequence="M2+M3+ARROW_DOWN"/>
      <key
            commandId="org.eclipse.statet.workbench.commands.SelectLast"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            platform="carbon"
            sequence="CTRL+SHIFT+ARROW_DOWN"/>
      
      <key
            commandId="org.eclipse.statet.ecommons.text.commands.GotoMatchingBracket"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M1+M2+P"/>
      
      <key
            commandId="org.eclipse.statet.ltk.commands.ToggleComment"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M1+M2+C"/>
      <key
            commandId="org.eclipse.statet.ltk.commands.StripComments"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M1+M2+D"/>
      <key
            commandId="org.eclipse.statet.ltk.commands.InsertAssignment"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M1+&lt;"/>
      <key
            commandId="org.eclipse.statet.ltk.commands.InsertAssignment"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M1+="/>
      <key
            commandId="org.eclipse.statet.ltk.commands.AddDocComment"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M1+M2+#"/>
      <key
            commandId="org.eclipse.statet.ltk.commands.AddDocComment"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M1+M2+/"/>
      <key
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            platform="carbon"
            sequence="M1+M2+/"/>
      <key
            commandId="org.eclipse.statet.ltk.commands.CorrectIndent"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M1+I"/>
      <key
            commandId="org.eclipse.statet.ltk.commands.ShowQuickSourceOutline"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M1+O"/>
      <key
            commandId="org.eclipse.statet.ltk.commands.ShowQuickElementOutline"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M1+F3"/>
      <key
            commandId="org.eclipse.statet.ltk.commands.ShowQuickElementHierarchy"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M1+T"/>
      
      <key
            commandId="org.eclipse.ui.edit.text.showInformation"
            contextId="org.eclipse.statet.workbench.contexts.StructuredElementViewer"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="F2"/>
      
      <key
            commandId="org.eclipse.statet.ltk.commands.QuickAssistRenameInFile"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M1+2 R"/>
      <key
            commandId="org.eclipse.statet.ltk.commands.QuickAssistConvertToPipeForward"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M1+2 P"/>
      
      <key
            commandId="org.eclipse.statet.ltk.commands.RefactorRenameInWorkspace"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M2+M3+R">
      </key>
      <key
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            platform="carbon"
            sequence="M2+M3+R">
      </key>
      <key
            commandId="org.eclipse.statet.ltk.commands.RefactorRenameInWorkspace"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            platform="carbon"
            sequence="COMMAND+ALT+R">
      </key>
      <key
            commandId="org.eclipse.statet.ltk.commands.RefactorInlineLocalVariable"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            sequence="M2+M3+I">
      </key>
      <key
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            platform="carbon"
            sequence="M2+M3+I">
      </key>
      <key
            commandId="org.eclipse.statet.ltk.commands.RefactorInlineLocalVariable"
            contextId="org.eclipse.statet.workbench.contexts.TextEditor"
            schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
            platform="carbon"
            sequence="COMMAND+ALT+I">
      </key>
   </extension>
   
   <extension
         point="org.eclipse.core.expressions.propertyTesters">
      <propertyTester
            id="org.eclipse.statet.ltk.expressionProperties.ContentTypeActivation"
            class="org.eclipse.statet.internal.ltk.ui.ActivatedContentTypeTester"
            namespace="org.eclipse.statet.ltk"
            properties="matchesActivatedContentType,matchesContentType"
            type="org.eclipse.core.runtime.IAdaptable"/>
      <propertyTester
            id="org.eclipse.statet.ltk.propertyTester.ModelElements"
            class="org.eclipse.statet.internal.ltk.ui.refactoring.ModelElementTester"
            namespace="org.eclipse.statet.ltk"
            properties="isElementSelection,isElementC1TypeSelection,isElementC2TypeSelection"
            type="org.eclipse.jface.viewers.ISelection"/>
   </extension>
   <extension
         point="org.eclipse.ui.handlers">
      <handler
            commandId="org.eclipse.statet.workbench.commands.PasteRaw"
            class="org.eclipse.statet.ltk.ui.sourceediting.actions.PasteRawHandler">
         <activeWhen>
            <with
                  variable="activePart">
               <instanceof
                     value="org.eclipse.statet.ltk.ui.sourceediting.SourceEditor1">
               </instanceof>
            </with>
         </activeWhen>
      </handler>
      <handler
            commandId="org.eclipse.statet.ltk.commands.ShowQuickSourceOutline"
            class="org.eclipse.statet.ltk.ui.sourceediting.actions.ShowQuickSourceOutlineHandler">
         <activeWhen>
            <with
                  variable="activePart">
               <instanceof
                     value="org.eclipse.statet.ltk.ui.sourceediting.SourceEditor1">
               </instanceof>
            </with>
         </activeWhen>
      </handler>
      <handler
            commandId="org.eclipse.statet.ltk.commands.ShowQuickElementOutline"
            class="org.eclipse.statet.ltk.ui.sourceediting.actions.ShowQuickElementOutlineHandler">
         <activeWhen>
            <with
                  variable="activePart">
               <instanceof
                     value="org.eclipse.statet.ltk.ui.sourceediting.SourceEditor1">
               </instanceof>
            </with>
         </activeWhen>
      </handler>
      <handler
            commandId="org.eclipse.statet.ltk.commands.ShowQuickElementHierarchy"
            class="org.eclipse.statet.ltk.ui.sourceediting.actions.ShowQuickElementHierarchyHandler">
         <activeWhen>
            <with
                  variable="activePart">
               <instanceof
                     value="org.eclipse.statet.ltk.ui.sourceediting.SourceEditor1">
               </instanceof>
            </with>
         </activeWhen>
      </handler>
      <handler
            commandId="org.eclipse.statet.ltk.commands.QuickAssistRenameInFile">
         <class class="org.eclipse.statet.ltk.ui.sourceediting.actions.QuickAssistCommandHandler"/>
         <activeWhen>
            <with
                  variable="activePart">
               <instanceof
                     value="org.eclipse.statet.ltk.ui.sourceediting.SourceEditor1">
               </instanceof>
            </with>
         </activeWhen>
      </handler>
   </extension>
   
   <extension
         point="org.eclipse.ui.contexts">
      <context
            id="org.eclipse.statet.ltk.contexts.EditSource1MenuSet"
            parentId="org.eclipse.ui.contexts.actionSet"
            name="StatET Source Editor Menus">
      </context>
   </extension>
   <extension
         point="org.eclipse.core.expressions.definitions">
      <definition
            id="org.eclipse.statet.ltk.expressions.isContextActive.EditSource1MenuSet">
         <with variable="activeContexts">
            <iterate
                  operator="or">
               <equals value="org.eclipse.statet.ltk.contexts.EditSource1MenuSet"/>
            </iterate>
         </with>
      </definition>
   </extension>
   
   <extension
         point="org.eclipse.ui.menus">
      <!-- edit -->
      <menuContribution
            locationURI="menu:edit?after=paste">
         <command
               commandId="org.eclipse.statet.workbench.commands.PasteRaw"
               label="%commands_PasteRaw_name">
            <visibleWhen>
               <reference
                     definitionId="org.eclipse.statet.ltk.expressions.isContextActive.EditSource1MenuSet"/>
            </visibleWhen>
         </command>
      </menuContribution>
      <menuContribution
            locationURI="menu:edit?after=selectAll">
         <menu
               label="%menus_Edit_ExpandSelectionTo_label"
               mnemonic="%menus_Edit_ExpandSelectionTo_mnemonic">
            <command
                  commandId="org.eclipse.statet.workbench.commands.SelectExpandEnclosing"
                  label="%commands_SelectEnclosing_name"
                  mnemonic="%menus_Edit_ExpandSelectionTo_Enclosing_mnemonic">
            </command>
            <command
                  commandId="org.eclipse.statet.workbench.commands.SelectExpandNext"
                  label="%commands_SelectNext_name"
                  mnemonic="%menus_Edit_ExpandSelectionTo_Next_mnemonic">
            </command>
            <command
                  commandId="org.eclipse.statet.workbench.commands.SelectExpandPrevious"
                  label="%commands_SelectPrevious_name"
                  mnemonic="%menus_Edit_ExpandSelectionTo_Previous_mnemonic">
            </command>
            <command
                  commandId="org.eclipse.statet.workbench.commands.SelectLast"
                  label="%commands_SelectLast_name"
                  mnemonic="%menus_Edit_ExpandSelectionTo_Last_mnemonic">
            </command>
            <visibleWhen>
               <reference
                     definitionId="org.eclipse.statet.ltk.expressions.isContextActive.EditSource1MenuSet"/>
            </visibleWhen>
         </menu>
      </menuContribution>
      
      <!-- source -->
      <menuContribution
            locationURI="menu:org.eclipse.ui.main.menu?after=edit">
         <menu
               id="org.eclipse.statet.base.menus.MainStatSource"
               label="Source"
               mnemonic="S">
            <separator
                  name="comment"
                  visible="true">
            </separator>
            <command
                  commandId="org.eclipse.statet.ltk.commands.ToggleComment"
                  mnemonic="%menus_Source_ToggleComment_mnemonic">
            </command>
            <command
                  commandId="org.eclipse.statet.ltk.commands.AddDocComment"
                  mnemonic="%menus_Source_AddDocComment_mnemonic">
            </command>
            <separator
                  name="comment.add"
                  visible="false">
            </separator>
            <separator
                  name="format"
                  visible="true">
            </separator>
            <command
                  commandId="org.eclipse.ui.edit.text.shiftRight"
                  mnemonic="%menus_Source_ShiftRight_mnemonic">
            </command>
            <command
                  commandId="org.eclipse.ui.edit.text.shiftLeft"
                  mnemonic="%menus_Source_ShiftLeft_mnemonic">
            </command>
            <command
                  commandId="org.eclipse.statet.ltk.commands.CorrectIndent"
                  label="%commands_CorrectIndent_name"
                  mnemonic="%menus_Source_CorrectIndent_mnemonic">
            </command>
            <separator
                  name="additions"
                  visible="false">
            </separator>
            <visibleWhen>
               <reference
                     definitionId="org.eclipse.statet.ltk.expressions.isContextActive.EditSource1MenuSet"/>
           </visibleWhen>
         </menu>
      </menuContribution>
      
      <!-- navigate -->
      <menuContribution
            locationURI="menu:navigate?after=open.ext">
         <command
               commandId="org.eclipse.ui.edit.text.open.hyperlink"
               mnemonic="%menus_Navigate_OpenHyperlink_mnemonic"
               style="push">
            <visibleWhen>
               <reference
                     definitionId="org.eclipse.statet.ltk.expressions.isContextActive.EditSource1MenuSet"/>
            </visibleWhen>
         </command>
         <command
               commandId="org.eclipse.jdt.ui.edit.text.java.open.editor"
               mnemonic="%menus_Navigate_OpenDeclaration_mnemonic"
               style="push">
            <visibleWhen>
               <reference
                     definitionId="org.eclipse.statet.ltk.expressions.isContextActive.EditSource1MenuSet"/>
            </visibleWhen>
         </command>
      </menuContribution>
      <menuContribution locationURI="menu:goTo">
         <command
               commandId="org.eclipse.statet.ecommons.text.commands.GotoMatchingBracket"
               label="%menus_Navigate_Goto_GotoMatchingBracket_label"
               mnemonic="%menus_Navigate_GoTo_GotoMatchingBracket_mnemonic"
               style="push">
            <visibleWhen>
               <reference
                     definitionId="org.eclipse.statet.ltk.expressions.isContextActive.EditSource1MenuSet"/>
            </visibleWhen>
         </command>
      </menuContribution>
      <menuContribution
            locationURI="menu:navigate?endof=show.ext">
         <command
               commandId="org.eclipse.statet.ltk.commands.ShowQuickSourceOutline"
               mnemonic="%menus_Navigate_ShowQuickOutline_mnemonic"
               style="push">
            <visibleWhen
                  checkEnabled="false">
               <reference
                     definitionId="org.eclipse.statet.ltk.expressions.isContextActive.EditSource1MenuSet"/>
            </visibleWhen>
         </command>
      </menuContribution>
      
      <!-- search -->
      <menuContribution
            locationURI="menu:org.eclipse.ui.main.menu?after=navigate">
         <!-- redefinition from search plugin -->
         <menu
               id="org.eclipse.search.menu"
               label="Search"
               mnemonic="a">
            <separator
                  name="internalDialogGroup"/><!-- not to be used by clients  -->
            <separator
                  name="dialogGroup"/>
            <separator
                  name="fileSearchContextMenuActionsGroup"
                  visible="true"/>
            <separator
                  name="contextMenuActionsGroup"
                  visible="true"/>
            <separator
                  name="occurencesActionsGroup"
                  visible="true"/>
            <separator
                  name="extraSearchGroup"
                  visible="true"/>
         </menu>
      </menuContribution>
      
      <!-- other -->
      <menuContribution
            locationURI="menu:window?after=newEditor">
         <dynamic
               id="org.eclipse.statet.ltk.menus.DocShareContributions"
               class="org.eclipse.ecf.docshare.menu.DocShareRosterMenuContributionItem">
            <visibleWhen
                  checkEnabled="false">
               <with
                     variable="activeEditor">
                  <instanceof
                        value="org.eclipse.ui.texteditor.ITextEditor">
                  </instanceof>
               </with>
            </visibleWhen>
         </dynamic>
      </menuContribution>
   </extension>
   
   <extension
         point="org.eclipse.core.resources.markers"
         id="org.eclipse.statet.ltk.resourceMarkers.InitialSelection">
      <persistent
            value="false">
      </persistent>
   </extension>
   <extension
         point="org.eclipse.ui.editors.annotationTypes">
      <type
            name="org.eclipse.statet.ltk.editorAnnotations.ErrorProblem"
            super="org.eclipse.ui.workbench.texteditor.error"
            markerType="org.eclipse.statet.ltk.resourceMarkers.SourceProblem"
            markerSeverity="2"/>
      <type
            name="org.eclipse.statet.ltk.editorAnnotations.WarningProblem"
            super="org.eclipse.ui.workbench.texteditor.warning"
            markerType="org.eclipse.statet.ltk.resourceMarkers.SourceProblem"
            markerSeverity="1"/>
      <type
            name="org.eclipse.statet.ltk.editorAnnotations.InfoProblem"
            super="org.eclipse.ui.workbench.texteditor.info"
            markerType="org.eclipse.statet.ltk.resourceMarkers.SourceProblem"
            markerSeverity="0"/>
      <type
            name="org.eclipse.statet.ecommons.text.editorAnnotations.CommonOccurrences"
            super="org.eclipse.jdt.ui.occurrences"/>
      <type
            name="org.eclipse.statet.ecommons.text.editorAnnotations.WriteOccurrences"
            super="org.eclipse.jdt.ui.occurrences.write"/>
      <type
            name="org.eclipse.statet.ecommons.text.editorAnnotations.ContentAssistOverwrite">
      </type>
   </extension>
   <extension
         point="org.eclipse.ui.editors.markerAnnotationSpecification">
      <!-- Preferences are copy of JDT values, but increased priority -->
      <specification
            annotationType="org.eclipse.statet.ecommons.text.editorAnnotations.WriteOccurrences"
            includeOnPreferencePage="false"
            presentationLayer="5"
            
            colorPreferenceKey="writeOccurrenceIndicationColor"
            colorPreferenceValue="240,216,168"
            overviewRulerPreferenceKey="writeOccurrenceIndicationInOverviewRuler"
            overviewRulerPreferenceValue="true"
            verticalRulerPreferenceKey="writeOccurrenceIndicationInVerticalRuler"
            verticalRulerPreferenceValue="false"
            highlightPreferenceKey="writeOccurrenceHighlighting"
            highlightPreferenceValue="true"
            textPreferenceKey="writeOccurrenceIndication"
            textPreferenceValue="false"
            textStylePreferenceKey="writeOccurrenceTextStyle"
            textStylePreferenceValue="NONE">
      </specification>
   </extension>
   
   <extension
         point="org.eclipse.ui.keywords">
      <keyword
            id="org.eclipse.statet.ltk.keywords.SourceAppearance"
            label="%keywords_Appearance"/>
      <keyword
            id="org.eclipse.statet.ltk.keywords.SourceTemplates"
            label="%keywords_Template"/>
      <keyword
            id="org.eclipse.statet.ltk.keywords.SourceEditor"
            label="%keywords_Editor"/>
      <keyword
            id="org.eclipse.statet.ltk.keywords.TaskTags"
            label="%keywords_TaskTag"/>
      <keyword
            id="org.eclipse.statet.ltk.keywords.SourceFormatting"
            label="%keywords_Formatting"/>
      <keyword
            id="org.eclipse.statet.ltk.keywords.SpellChecking"
            label="%keywords_SpellChecking"/>
      <keyword
            id="org.eclipse.statet.ltk.keywords.SourceContentAssist"
            label="%keywords_ContentAssist"/>
      <keyword
            id="org.eclipse.statet.ltk.keywords.AutoBracket"
            label="%keywords_AutoBracket"/>
      <keyword
            id="org.eclipse.statet.ltk.keywords.AutoIndent"
            label="%keywords_AutoIndent"/>
      <keyword
            id="org.eclipse.statet.ltk.keywords.AutoWrap"
            label="%keywords_AutoWrap"/>
   </extension>
   
   <extension
         point="org.eclipse.ui.themes">
      <themeElementCategory
            id="org.eclipse.statet.workbench.themes.ElementCategory"
            label="%themes_ElementCategory_label">
      </themeElementCategory>
      
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.DocViewBackgroundColor"
            categoryId="org.eclipse.statet.workbench.themes.ElementCategory"
            label="%themes_DocViewBackgroundColor_label"
            value="253,253,248">
         <description>
            Background color used when displaying documentation (e.g. R Help)
         </description>
      </colorDefinition>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.DocViewColor"
            categoryId="org.eclipse.statet.workbench.themes.ElementCategory"
            label="%themes_DocViewDefaultColor_label"
            value="0,0,0">
      </colorDefinition>
      <fontDefinition
            id="org.eclipse.statet.workbench.themes.DocViewFont"
            categoryId="org.eclipse.statet.workbench.themes.ElementCategory"
            label="%themes_DocViewFont_label">
         <description>
            Text font used when displaying documentation (e.g. R Help)
         </description>
      </fontDefinition>
      <fontDefinition
            id="org.eclipse.statet.workbench.themes.ConsoleFont"
            categoryId="org.eclipse.statet.workbench.themes.ElementCategory"
            label="%themes_ConsoleFont_label"
            defaultsTo="org.eclipse.jface.textfont">
         <description>
            Text font used for input and output in tool consoles (e.g. R Console)
         </description>
      </fontDefinition>
      <fontDefinition
            id="org.eclipse.statet.workbench.themes.TableFont"
            categoryId="org.eclipse.statet.workbench.themes.ElementCategory"
            label="%themes_TableFont_label"
            defaultsTo="org.eclipse.jface.dialogfont">
         <description>
            Text font used for text in data table viewer and editors
         </description>
      </fontDefinition>
      
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeDefaultColor"
            isEditable="false"
            label=""
            value="0,0,0"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeBracketColor"
            isEditable="false"
            label=""
            value="0,0,0"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodePreprocessorColor"
            isEditable="false"
            label=""
            value="96,159,251"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeCommentColor"
            isEditable="false"
            label=""
            value="65,125,70"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeCommentTaskTagColor"
            isEditable="false"
            label=""
            value="65,125,95"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeDocuColor"
            isEditable="false"
            label=""
            value="15,125,160"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeDocuTagColor"
            isEditable="false"
            label=""
            value="135,160,175"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeKeywordColor"
            isEditable="false"
            label=""
            value="125,0,95"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeConstColor"
            isEditable="false"
            label=""
            value="90,5,165"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeStringColor"
            isEditable="false"
            label=""
            value="65,65,175"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeNumberColor"
            isEditable="false"
            label=""
            value="0,30,130"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeOperatorColor"
            isEditable="false"
            label=""
            value="165,100,35"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeSubColor"
            isEditable="false"
            label=""
            value="150,45,0"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeDocCommandColor"
            isEditable="false"
            label=""
            value="110,0,220"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeDocCommandSpecialColor"
            isEditable="false"
            label=""
            value="65,0,125"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeDoc2ndColor"
            isEditable="false"
            label=""
            value="110,65,65"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeDoc2ndCommandColor"
            isEditable="false"
            label=""
            value="160,65,125"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeDoc2ndSubColor"
            isEditable="false"
            label=""
            value="160,95,125"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeVerbatimColor"
            isEditable="false"
            label=""
            value="80,80,125"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeUndefinedColor"
            isEditable="false"
            label=""
            value="235,45,90"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.CodeMod1BackgroundColor"
            isEditable="false"
            label=""
            value="230,240,240"/>
      
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.ConsoleInfoColor"
            isEditable="false"
            label=""
            value="30,75,180"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.ConsoleInputColor"
            isEditable="false"
            label=""
            value="30,160,95"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.ConsoleOutputColor"
            isEditable="false"
            label=""
            value="0,0,0"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.ConsoleErrorColor"
            isEditable="false"
            label=""
            value="255,5,5"/>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.Console2ndOutputColor"
            isEditable="false"
            label=""
            value="125,125,135"/>
      
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.MatchingBracketColor"
            isEditable="false"
            label=""
            value="191,191,191">
      </colorDefinition>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.InformationBackgroundColor"
            isEditable="false"
            label=""
            value="255,255,223">
      </colorDefinition>
      <colorDefinition
            id="org.eclipse.statet.workbench.themes.InformationColor"
            isEditable="false"
            label=""
            value="0,0,0">
      </colorDefinition>
      
      <theme
            id="org.eclipse.ui.ide.systemDefault">
         <colorOverride
               id="org.eclipse.statet.workbench.themes.DocViewBackgroundColor"
               value="COLOR_INFO_BACKGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.DocViewColor"
               value="COLOR_INFO_FOREGROUND">
         </colorOverride>
         
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeDefaultColor"
               value="COLOR_WIDGET_FOREGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodePreprocessorColor"
               value="COLOR_LIST_FOREGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeCommentColor"
               value="COLOR_LIST_SELECTION">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeCommentTaskTagColor"
               value="COLOR_WIDGET_NORMAL_SHADOW">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeDocuColor"
               value="COLOR_LIST_SELECTION">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeDocuTagColor"
               value="COLOR_WIDGET_NORMAL_SHADOW">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeKeywordColor"
               value="COLOR_LIST_FOREGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeKeywordColor"
               value="COLOR_LIST_FOREGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeConstColor"
               value="COLOR_LIST_FOREGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeStringColor"
               value="COLOR_LIST_FOREGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeNumberColor"
               value="COLOR_LIST_FOREGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeOperatorColor"
               value="COLOR_WIDGET_FOREGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeSubColor"
               value="COLOR_WIDGET_FOREGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeDocCommandColor"
               value="COLOR_LIST_FOREGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeDocCommandSpecialColor"
               value="COLOR_LIST_FOREGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeDoc2ndColor"
               value="COLOR_WIDGET_FOREGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeDoc2ndCommandColor"
               value="COLOR_LIST_FOREGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeDoc2ndSubColor"
               value="COLOR_LIST_FOREGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeVerbatimColor"
               value="COLOR_WIDGET_NORMAL_SHADOW">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.CodeUndefinedColor"
               value="COLOR_LIST_SELECTION">
         </colorOverride>
         
         <colorOverride
               id="org.eclipse.statet.workbench.themes.ConsoleInfoColor"
               value="COLOR_WIDGET_NORMAL_SHADOW">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.ConsoleInputColor"
               value="COLOR_LIST_FOREGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.ConsoleOutputColor"
               value="COLOR_WIDGET_FOREGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.ConsoleErrorColor"
               value="COLOR_LIST_SELECTION">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.Console2ndOutputColor"
               value="COLOR_WIDGET_FOREGROUND">
         </colorOverride>
         
         <colorOverride
               id="org.eclipse.statet.workbench.themes.MatchingBracketColor"
               value="COLOR_WIDGET_NORMAL_SHADOW">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.InformationBackgroundColor"
               value="COLOR_INFO_BACKGROUND">
         </colorOverride>
         <colorOverride
               id="org.eclipse.statet.workbench.themes.InformationColor"
               value="COLOR_INFO_FOREGROUND">
         </colorOverride>
      </theme>
   </extension>
   <extension
         point="org.eclipse.e4.ui.css.core.elementProvider">
      <provider
             class="org.eclipse.statet.internal.ltk.ui.css.dom.LtkSwtElementProvider">
         <widget
               class="org.eclipse.statet.ltk.ui.sourceediting.swt.EnhStyledText"/>
      </provider>
   </extension>
   <extension
         point="org.eclipse.e4.ui.css.core.propertyHandler">
      <handler
            adapter="org.eclipse.statet.internal.ltk.ui.css.dom.EnhStyledTextElement"
            handler="org.eclipse.statet.internal.ltk.ui.css.properties.NoopCssPropertyHandler">
         <property-name
               name="background-color"/>
         <property-name
               name="color"/>
      </handler>
      <handler
            adapter="org.eclipse.statet.internal.ltk.ui.css.dom.EnhStyledTextElement"
            handler="org.eclipse.statet.internal.ltk.ui.css.properties.NoopCssPropertyHandler"
            composite="true">
         <property-name
               name="font"/>
         <property-name
               name="font-family"/>
         <property-name
               name="font-size"/>
         <property-name
               name="font-adjust"/>
         <property-name
               name="font-stretch"/>
         <property-name
               name="font-style"/>
         <property-name
               name="font-variant"/>
         <property-name
               name="font-weight"/>
      </handler>
   </extension>
   <extension
         point="org.eclipse.e4.ui.css.swt.theme">
      <stylesheet
            uri="css/e4_dark.css">
         <themeid
               refid="org.eclipse.e4.ui.css.theme.e4_dark"/>
      </stylesheet>
   </extension>
   
   <extension
         point="org.eclipse.core.runtime.preferences">
      <initializer
            class="org.eclipse.statet.internal.ltk.ui.LtkUIPreferenceInitializer" />
   </extension>
   <extension
         point="org.eclipse.ui.preferencePages">
      <page
            id="org.eclipse.statet.ltk.preferencePages.SourceEditors"
            category="org.eclipse.ui.preferencePages.GeneralTextEditor"
            name="%preferencePages_SourceEditors_name"
            class="org.eclipse.statet.internal.ltk.ui.config.EditorsPreferencePage">
         <keywordReference id="org.eclipse.statet.ltk.keywords.SourceEditor"/>
         <keywordReference id="org.eclipse.statet.ltk.keywords.SourceAppearance"/>
         <keywordReference id="org.eclipse.statet.ltk.keywords.SourceContentAssist"/>
      </page>
   </extension>
   
</plugin>
